package com.kuyuntech.cofarcooking.device.sdk.devmode.core;

import com.kuyuntech.cofarcooking.device.sdk.constant.core.DevStatus;
import com.kuyuntech.cofarcooking.device.sdk.constant.core.MotorDirections;
import com.kuyuntech.cofarcooking.device.sdk.constant.core.MotorHeightSpeed;
import com.kuyuntech.cofarcooking.device.sdk.constant.core.WorkModes;
import com.kuyuntech.cofarcooking.device.sdk.eventbus.core.DevInfo;
import com.kuyuntech.cofarcooking.device.sdk.eventbus.event.DevPromptEvent;
import com.kuyuntech.cofarcooking.device.sdk.util.core.CofarSDK;

import java.sql.Time;
import java.util.Timer;
import java.util.TimerTask;

public class Turbo extends BaseDevMode{

    private Timer timer;

    private Long lastJogTime = 0L;

    private Long restStartTime = 0L;

    private boolean counting = false;

    public Turbo(){

        this.setMode(WorkModes.TURBO);


        //时间
        this.setMinTime(0);
        this.setMaxTime(60);
        this.setDefaultTime(60);
        this.setTimeChange(false);

        //电机
        this.setDefaultMotorGear(12);
        this.setMaxMotorGear(12);
        this.setMaxMotorGear(12);
        this.setMotorGearChange(false);
        this.setMotorDirectionChange(false);

        //温度
        this.setDefaultTemp(0);
        this.setMinTemp(0);
        this.setMaxTemp(0);
        this.setTempChange(false);

        this.setDiyCountDown(true);

    }


    @Override
    public void start() {



        lastJogTime = System.currentTimeMillis();
        if(( lastJogTime - restStartTime) < (500)){ //暂时不限制
            restStartTime = lastJogTime;
            return;
        }



        if(!counting){
            CofarSDK.startCountDown();
            this.counting = true;
        }


        CofarSDK.jog();

    }


    @Override
    public void onCountDown(TimerTask timer) {

        DevInfo devInfo = CofarSDK.devInfo();

        if (devInfo.getRemainTime() <= 0) {
            timer.cancel();
            restStartTime = System.currentTimeMillis();
            devInfo.setRemainTime((short) 0);
            this.counting = false;
            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
//            CofarSDK.cfgMotorGearNative((byte) this.getDefaultMotorGear());
//            CofarSDK.cfgTimeNatvie(this.getDefaultTime());
            return ;
        }

        if ((System.currentTimeMillis() - lastJogTime) > 1000) {
            timer.cancel();
            restStartTime = 0L;
            this.counting = false;
            devInfo.setRemainTime((short) 0);
            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
//            CofarSDK.cfgMotorGearNative((byte) this.getDefaultMotorGear());
//            CofarSDK.cfgTimeNatvie(this.getDefaultTime());
            return ;
        }

        devInfo.setRemainTime((short) (devInfo.getRemainTime() - 1));

    }

    @Override
    public void stop() {
        super.stop();

    }
}
